Index: /trunk/src/sh_unix.c
===================================================================
--- /trunk/src/sh_unix.c	(revision 584)
+++ /trunk/src/sh_unix.c	(revision 1)
@@ -1893,20 +1567,15 @@
    */
 #if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
-  if (skey->mlock_failed == S_FALSE)
-    {
-      if ( (-1) == sh_unix_mlock( FIL__, __LINE__, 
-				  (char *) skey, sizeof (sh_key_t)) ) 
+  if (skey->mlock_failed == SL_FALSE)
+    {
+      if ( (-1) == sh_unix_mlock( (char *) skey, sizeof (sh_key_t)) ) 
 	{
-	  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-	  skey->mlock_failed = S_TRUE;
-	  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
+	  skey->mlock_failed = SL_TRUE;
 	}
     }
 #else
-  if (skey->mlock_failed == S_FALSE)
-    {
-      SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-      skey->mlock_failed = S_TRUE;
-      SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
+  if (skey->mlock_failed == SL_FALSE)
+    {
+      skey->mlock_failed = SL_TRUE;
     }
 #endif
@@ -1918,5 +1587,5 @@
 char * chroot_dir = NULL;
 
-int sh_unix_set_chroot(const char * str)
+int sh_unix_set_chroot(char * str)
 {
   size_t len;
@@ -1929,5 +1598,5 @@
     {
       len = strlen(str) + 1;
-      chroot_dir = calloc(1,strlen(str) + 1);  /* only once */
+      chroot_dir = malloc(strlen(str) + 1);  /* only once */
       if (!chroot_dir)
 	{
@@ -1942,5 +1611,5 @@
 }
 
-int sh_unix_chroot(void)
+int sh_unix_chroot()
 {
   int status;
@@ -1951,11 +1620,9 @@
       if ( (-1) == status ) 
 	{
-	  char errbuf[SH_ERRBUF_SIZE];
 	  status = errno;
 	  sh_error_handle ((-1), FIL__, __LINE__, status, MSG_W_CHDIR,
-			   sh_error_message (status, errbuf, sizeof(errbuf)), chroot_dir);
+			   sh_error_message (status), chroot_dir);
 	  aud_exit(FIL__, __LINE__, EXIT_FAILURE);
 	}
-      /* flawfinder: ignore */
       return (chroot(chroot_dir));
     }
@@ -1964,5 +1631,5 @@
 /* #ifdef SH_WITH_SERVER */
 #else
-int sh_unix_chroot(void) { return 0; }
+int sh_unix_chroot() { return 0; }
 #endif
 
@@ -1971,5 +1638,5 @@
 static int block_setdeamon = 0;
 
-int sh_unix_setdeamon(const char * dummy)
+int sh_unix_setdeamon(char * dummy)
 {
   int    res = 0;
@@ -1981,5 +1648,5 @@
 
   if (dummy == NULL)
-    sh.flag.isdaemon = S_TRUE;
+    sh.flag.isdaemon = ON;
   else 
     res = sh_util_flagval (dummy, &sh.flag.isdaemon);
@@ -1994,8 +1661,8 @@
 #endif
 
-int sh_unix_setnodeamon(const char * dummy)
+int sh_unix_setnodeamon(char * dummy)
 {
   int    res = 0;
-  
+
   SL_ENTER(_("sh_unix_setnodeamon"));
 
@@ -2004,5 +1671,5 @@
 
   if (dummy == NULL)
-    sh.flag.isdaemon = S_FALSE;
+    sh.flag.isdaemon = OFF;
   else 
     res = sh_util_flagval (dummy, &sh.flag.isdaemon);
@@ -2020,9 +1687,6 @@
   pid_t  oldpid = getpid();
 #if defined(SH_WITH_SERVER) 
-  extern int sh_socket_open_int (void);
-#endif
-  char errbuf[SH_ERRBUF_SIZE];
-
-  extern void sh_kill_sub();
+  extern int sh_socket_open_int ();
+#endif
 
   SL_ENTER(_("sh_unix_init"));
@@ -2035,7 +1699,5 @@
     case 0:  break;                             /* child process continues */
     case -1: SL_RETURN((-1),_("sh_unix_init")); /* error                   */
-    default:                                    /* parent process exits    */
-      sh_kill_sub(); 
-      aud__exit(FIL__, __LINE__, 0);
+    default: aud__exit(FIL__, __LINE__, 0);     /* parent process exits    */
     }
 
@@ -2046,12 +1708,9 @@
 
     setsid();            /* should not fail         */
-    sh.pid = (UINT64) getpid();
 
     switch (aud_fork(FIL__, __LINE__)) {
     case 0:  break;                             /* child process continues */
     case -1: SL_RETURN((-1),_("sh_unix_init")); /* error                   */
-    default:                                    /* parent process exits    */
-      sh_kill_sub(); 
-      aud__exit(FIL__, __LINE__, 0);
+    default: aud__exit(FIL__, __LINE__, 0);     /* parent process exits    */
     }
 
@@ -2059,5 +1718,4 @@
      */
     sh_unix_memlock();
-    sh.pid = (UINT64) getpid();
 
   } else {
@@ -2076,5 +1734,5 @@
       status = errno;
       sh_error_handle ((-1), FIL__, __LINE__, status, MSG_W_CHDIR,
-		       sh_error_message (status, errbuf, sizeof(errbuf)), "/");
+		       sh_error_message (status), "/");
       aud_exit(FIL__, __LINE__, EXIT_FAILURE);
     }
@@ -2105,40 +1763,14 @@
   sh_unix_zeroenv();
 
+
+  /* close all file descriptors, and 
+   * open first three streams to /dev/null 
+   */
   if (goDaemon == 1)
     {
-      /* Close first tree file descriptors 
-       */ 
-      sl_close_fd (FIL__, __LINE__, 0);  /* if running as daemon */
-      sl_close_fd (FIL__, __LINE__, 1);  /* if running as daemon */
-      sl_close_fd (FIL__, __LINE__, 2);  /* if running as daemon */
-
-      /* Enable full error logging
-       */
-      sh_error_only_stderr (S_FALSE);
-
-      /* open first three streams to /dev/null 
-       */
-      status = aud_open(FIL__, __LINE__, SL_NOPRIV, _("/dev/null"), O_RDWR, 0);
-      if (status < 0)
-	{
-	  status = errno;
-	  sh_error_handle((-1), FIL__, __LINE__, status, MSG_E_SUBGEN, 
-			  sh_error_message(status, errbuf, sizeof(errbuf)), _("open"));
-	  aud_exit(FIL__, __LINE__, EXIT_FAILURE);
-	}
-
-      status = retry_aud_dup(FIL__, __LINE__, 0); 
-      if (status >= 0)
-	retry_aud_dup(FIL__, __LINE__, 0);
-
-      if (status < 0)
-	{
-	  status = errno;
-	  sh_error_handle((-1), FIL__, __LINE__, status, MSG_E_SUBGEN, 
-			  sh_error_message(status, errbuf, sizeof(errbuf)), _("dup"));
-	  aud_exit(FIL__, __LINE__, EXIT_FAILURE);
-	}
-
-      sh_error_enable_unsafe (S_TRUE);
+      sh_unix_closeall (0, -1);  /* if running as daemon */
+      aud_open(FIL__, __LINE__, SL_NOPRIV, _("/dev/null"), O_RDWR, 0);
+      retry_aud_dup(FIL__, __LINE__, 0); 
+      retry_aud_dup(FIL__, __LINE__, 0);
 #if defined(HAVE_LIBPRELUDE)
       sh_prelude_reset ();
@@ -2173,5 +1805,5 @@
   else
     {
-      sh_error_enable_unsafe (S_TRUE);
+      sh_unix_closeall(3, -1);  /* if not daemon */
 #if defined(HAVE_LIBPRELUDE)
       sh_prelude_reset ();
@@ -2189,5 +1821,5 @@
       status = errno;
       sh_error_handle((-1), FIL__, __LINE__, status, MSG_E_SUBGEN, 
-			  sh_error_message(status, errbuf, sizeof(errbuf)), _("chroot"));
+			  sh_error_message(status), _("chroot"));
       aud_exit(FIL__, __LINE__, EXIT_FAILURE);
     }
@@ -2198,75 +1830,4 @@
 
   SL_RETURN((0),_("sh_unix_init"));
-}
-
-/* --- run a command, securely --- */
-
-int sh_unix_run_command (const char * str)
-{
-  pid_t  pid;
-  char * arg[4];
-  char * env[5];
-  char * path = sh_util_strdup(_("/bin/sh"));
-
-  int  status = -1;
-
-  arg[0] = sh_util_strdup(_("/bin/sh"));
-  arg[1] = sh_util_strdup(_("-c"));
-  arg[2] = sh_util_strdup(str);
-  arg[3] = NULL;
-
-  env[0] = sh_util_strdup(_("PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/ucb"));
-  env[1] = sh_util_strdup(_("SHELL=/bin/sh"));
-  env[2] = sh_util_strdup(_("IFS= \t\n"));
-  if (getenv("TZ")) {                         /* flawfinder: ignore */
-    char * tz = sh_util_strdup(getenv("TZ")); /* flawfinder: ignore */
-    size_t tzlen = strlen(tz);
-    if (S_TRUE == sl_ok_adds (4, tzlen)) {
-	env[3] = SH_ALLOC(4+tzlen);
-	sl_strlcpy(env[3], "TZ=", 4);
-	sl_strlcat(env[3], tz   , 4+tzlen);
-    } else {
-      env[3] = NULL;
-    }
-  } else {
-    env[3] = NULL;
-  }
-  env[4] = NULL;
-
-  pid = fork();
-
-  if (pid == (pid_t)(-1))
-    {
-      return -1;
-    }
-
-  else if (pid == 0) /* child */
-    {
-      memset(skey, 0, sizeof(sh_key_t));
-      (void) umask(S_IRGRP|S_IWGRP|S_IXGRP|S_IROTH|S_IWOTH|S_IXOTH);
-      sh_unix_closeall (3, -1, S_TRUE); /* in child process */
-      execve(path, arg, env);
-      _exit(EXIT_FAILURE);
-    }
-
-  else /* parent */
-    {
-      int r;
-
-      while((r = waitpid(pid, &status, WUNTRACED)) != pid && r != -1) ;
-
-#if !defined(USE_UNO)
-      if (r == -1 || !WIFEXITED(status)) 
-	{
-	  status = -1;
-	}
-      else
-	{
-	  status = WEXITSTATUS(status);
-	}
-#endif
-     }
-
-  return status;
 }
 
@@ -2284,8 +1845,5 @@
   struct tm   aa;
   struct tm   bb;
-
-  struct tm * aptr;
-  struct tm * bptr;
-
+  struct tm * cc;
   int  sign =  0;
   int  diff =  0;
@@ -2295,50 +1853,32 @@
   SL_ENTER(_("t_zone"));
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GMTIME_R)
-  aptr = gmtime_r (xx, &aa);
-#else
-  aptr = gmtime(xx);
-  if (aptr)
-    memcpy (&aa, aptr, sizeof(struct tm));
-#endif
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  bptr = localtime_r (xx, &bb);
-#else
-  bptr = localtime(xx);
-  if (bptr) 
-    memcpy (&bb, bptr, sizeof(struct tm));
-#endif
-
-  if (bptr && aptr)
-    {
-      /* Check for datum wrap-around.
-       */
-      if      ((aa.tm_mday == 1) && (aa.tm_mday < bb.tm_mday) && (aa.tm_hour < bb.tm_hour))
-	sign = ( 1);
-      else if (aa.tm_year < bb.tm_year)
-	sign = (-1);
-      else if (aa.tm_mon  < bb.tm_mon)
-	sign = (-1);
-      else if (aa.tm_mday < bb.tm_mday)
-	sign = (-1);
-      else if (bb.tm_year < aa.tm_year)
-	sign = ( 1);
-      else if (bb.tm_mon  < aa.tm_mon)
-	sign = ( 1);
-      else if (bb.tm_mday < aa.tm_mday)
-	sign = ( 1);
-      
-      diff = aa.tm_hour * 60 + aa.tm_min;
-      diff = (bb.tm_hour * 60 + bb.tm_min) - diff;
-      diff = diff - (sign * 24 * 60);   /* datum wrap-around correction */
-      hh = diff / 60;
-      mm = diff - (hh * 60);
-      sl_snprintf (tz, sizeof(tz), _("%+03d%02d"), hh, mm);                /* known to fit  */
-    }
-  else
-    {
-      sl_snprintf (tz, sizeof(tz), _("%+03d%02d"), 0, 0);
-    }
+
+  cc = gmtime (xx);
+  memcpy (&aa, cc, sizeof(struct tm));
+  cc = localtime (xx);
+  memcpy (&bb, cc, sizeof(struct tm));
+
+  /* Check for datum wrap-around.
+   */
+  if      (aa.tm_year < bb.tm_year)
+    sign = (-1);
+  else if (aa.tm_mon  < bb.tm_mon)
+    sign = (-1);
+  else if (aa.tm_mday < bb.tm_mday)
+    sign = (-1);
+  else if (bb.tm_year < aa.tm_year)
+    sign = ( 1);
+  else if (bb.tm_mon  < aa.tm_mon)
+    sign = ( 1);
+  else if (bb.tm_mday < aa.tm_mday)
+    sign = ( 1);
+
+  diff = aa.tm_hour * 60 + aa.tm_min;
+  diff = (bb.tm_hour * 60 + bb.tm_min) - diff;
+  diff = diff - (sign * 24 * 60);   /* datum wrap-around correction */
+  hh = diff / 60;
+  mm = diff - (hh * 60);
+  sprintf (tz, _("%+03d%02d"), hh, mm);                /* known to fit  */
+
   SL_RETURN(tz, _("t_zone"));
 }
@@ -2369,5 +1909,5 @@
 }
 
-int sh_unix_settimeserver (const char * address)
+int sh_unix_settimeserver (char * address)
 {
 
@@ -2406,14 +1946,13 @@
 #endif
 
-char * sh_unix_time (time_t thetime, char * buffer, size_t len)
+char * sh_unix_time (time_t thetime)
 {
 
   int           status;
-  char          AsciiTime[81];                       /* local time   */
+
   time_t        time_now;
   struct tm   * time_ptr;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  struct tm     time_tm;
-#endif
+  static char   AsciiTime[81];                       /* local time   */
+  static char   RetTime[81];                         /* local time   */
 #ifdef SH_USE_XML
   static char   deftime[] = N_("0000-00-00T00:00:00"); /* default time */
@@ -2445,17 +1984,4 @@
       else /* have a timeserver address */
 	{ 
-	  /* don't call timeserver more than once per second */
-	  static time_t  time_old   = 0;
-	  time_t         time_new;
-	  static time_t  time_saved = 0;
-	  (void) time (&time_new);
-	  if ((time_new == time_old) && (time_saved != 0))
-	    {
-	      time_now = time_saved;
-	      goto end;
-	    }
-	  time_old = time_new;
-
-
 	  fd = connect_port_2 (sh.srvtime.name, sh.srvtime.alt, 
 			       IPPORT_TIMESERVER, 
@@ -2470,5 +1996,5 @@
 				   _("time"), sh.srvtime.name);
 		}
-	      sl_close_fd(FIL__, __LINE__, fd);
+	      close(fd);
 	    }
 	  else
@@ -2477,5 +2003,4 @@
 			       MSG_E_NET, errmsg, error_call,
 			       _("time"), sh.srvtime.name);
-	      errflag = error_num;
 	      fail = 1;
 	    }
@@ -2483,10 +2008,6 @@
 	  if (fail == 0) 
 	    { 
-	      unsigned long   ltmp;
-	      UINT32          ttmp;
-	      memcpy(&ttmp, net_time, sizeof(UINT32)); ltmp = ttmp;
-	      time_now = ntohl(ltmp) - UNIXEPOCH;
-	      time_saved = time_now;
-
+	      time_now = ntohl(* (long *) net_time) - UNIXEPOCH;
+	      /* fprintf(stderr, "TIME IS %ld\n", time_now); */
 	      if (failerr == 1) {
 		failerr = 0;
@@ -2499,6 +2020,4 @@
 	    {
 	      (void) time (&time_now);
-	      time_saved = 0;
-
 	      if (failerr == 0)
 		{
@@ -2509,6 +2028,4 @@
 		}
 	    }
-	end:
-	  ; /* 'label at end of compound statement' */
 	}
     }
@@ -2533,20 +2050,12 @@
 #endif
 
-  if (time_now == (-1) )
-    {
-      sl_strlcpy(buffer, _(deftime), len);
-      SL_RETURN(buffer, _("sh_unix_time"));
-    }
+  if (time_now == (-1) ) 
+    SL_RETURN( _(deftime), _("sh_unix_time"));
   else
-    {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-      time_ptr   = localtime_r (&time_now, &time_tm);
-#else
-      time_ptr   = localtime (&time_now);
-#endif
-    }
+    time_ptr   = localtime (&time_now);
+
   if (time_ptr != NULL) 
     {
-      status = strftime (AsciiTime, sizeof(AsciiTime),
+      status = strftime (AsciiTime, 80,
 #ifdef SH_USE_XML
 			 _("%Y-%m-%dT%H:%M:%S%%s"),
@@ -2556,28 +2065,22 @@
 			 time_ptr);
 
-      sl_snprintf(buffer, len, AsciiTime, t_zone(&time_now));
-
-      if ( (status == 0) || (status == sizeof(AsciiTime)) )
-	{
-	  sl_strlcpy(buffer, _(deftime), len);
-	  SL_RETURN( buffer, _("sh_unix_time"));
-	}
+      sl_snprintf(RetTime, 80, AsciiTime, t_zone(&time_now));
+
+      if ( (status == 0) || (status == 80) ) 
+	SL_RETURN( _(deftime), _("sh_unix_time"));
       else
-	{
-	  SL_RETURN(buffer, _("sh_unix_time"));
-	}
+	SL_RETURN( &RetTime[0], _("sh_unix_time"));
     }
 
   /* last resort
    */
-  sl_strlcpy(buffer, _(deftime), len);
-  SL_RETURN( buffer, _("sh_unix_time"));
+  SL_RETURN( _(deftime), _("sh_unix_time"));
 }
 
 static int sh_unix_use_localtime = S_FALSE;
 
-/* whether to use localtime for file timestamps in logs
+/* whether to use localtime for file timesatams in logs
  */
-int sh_unix_uselocaltime (const char * c)
+int sh_unix_uselocaltime (char * c)
 {
   int i;
@@ -2588,5 +2091,5 @@
 }
     
-char * sh_unix_gmttime (time_t thetime, char * buffer, size_t len)
+char * sh_unix_gmttime (time_t thetime)
 {
 
@@ -2594,8 +2097,5 @@
 
   struct tm   * time_ptr;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS)
-  struct tm     time_tm;
-#endif
-  char   AsciiTime[81];                       /* GMT time   */
+  static char   AsciiTime[81];                       /* GMT time   */
 #ifdef SH_USE_XML
   static char   deftime[] = N_("0000-00-00T00:00:00"); /* default time */
@@ -2607,19 +2107,8 @@
 
   if (sh_unix_use_localtime == S_FALSE)
-    {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GMTIME_R)
-      time_ptr   = gmtime_r (&thetime, &time_tm);
-#else
-      time_ptr   = gmtime (&thetime);
-#endif
-    }
+    time_ptr   = gmtime (&thetime);
   else
-    {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-      time_ptr   = localtime_r (&thetime, &time_tm);
-#else
-      time_ptr   = localtime (&thetime);
-#endif
-    }
+    time_ptr   = localtime (&thetime);
+
   if (time_ptr != NULL) 
     {
@@ -2632,375 +2121,117 @@
 			 time_ptr);
 
-      if ( (status == 0) || (status == 80) )
-	sl_strlcpy(buffer, _(deftime), len);
+      if ( (status == 0) || (status == 80) ) 
+	SL_RETURN( _(deftime), _("sh_unix_gmttime"));
       else
-	sl_strlcpy(buffer, AsciiTime, len);
-      SL_RETURN( buffer, _("sh_unix_gmttime"));
+	SL_RETURN( &AsciiTime[0], _("sh_unix_gmttime"));
     }
 
   /* last resort
    */
-  sl_strlcpy(buffer, _(deftime), len);
-  SL_RETURN( buffer, _("sh_unix_gmttime"));
-}
-
-
-char *  sh_unix_getUIDdir (int level, uid_t uid, char * out, size_t len)
+  SL_RETURN( _(deftime), _("sh_unix_gmttime"));
+}
+
+
+
+char *  sh_unix_getUIDdir (int level, uid_t uid)
 {
   struct passwd * tempres;
   int    status = 0;
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWUID_R)
-  struct passwd pwd;
-  char   * buffer;
-#endif
-  char errbuf[SH_ERRBUF_SIZE];
-
   SL_ENTER(_("sh_unix_getUIDdir"));
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWUID_R)
-  buffer = SH_ALLOC(SH_PWBUF_SIZE);
-  sh_getpwuid_r(uid, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
   errno = 0;
   tempres = sh_getpwuid(uid);
   status = errno;
-#endif
 
   if (tempres == NULL) {
     sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_PWNULL,
-		     sh_error_message(status, errbuf, sizeof(errbuf)),
+		     sh_error_message(status),
 		     _("getpwuid"), (long) uid, _("completely missing"));
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-    SH_FREE(buffer);
-#endif
     SL_RETURN( NULL, _("sh_unix_getUIDdir"));
   }
 
   if (tempres->pw_dir != NULL) {
-    sl_strlcpy(out, tempres->pw_dir, len);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-    SH_FREE(buffer);
-#endif
-    SL_RETURN( out, _("sh_unix_getUIDdir"));
+    SL_RETURN( tempres->pw_dir, _("sh_unix_getUIDdir"));
   } else {
     sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_PWNULL,
-		     sh_error_message(status, errbuf, sizeof(errbuf)),
+		     sh_error_message(status),
 		     _("getpwuid"), (long) uid, _("pw_dir"));
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-    SH_FREE(buffer);
-#endif
     SL_RETURN( NULL, _("sh_unix_getUIDdir"));
   }
 }
 
-/* ------------------- Caching ----------------*/
-#include "zAVLTree.h"
-
-#define CACHE_GID 0
-#define CACHE_UID 1
-
-struct user_id {
-  char  * name;
-  uid_t   id;
-  struct user_id * next;
-};
-
-static struct user_id  * uid_list = NULL;
-static struct user_id  * gid_list = NULL;
-
-SH_MUTEX_STATIC(mutex_cache, PTHREAD_MUTEX_INITIALIZER);
-
-static void sh_userid_free(struct user_id * item)
-{
-  while (item)
-    {
-      struct user_id * user = item;
-      item = item->next;
-
-      SH_FREE(user->name);
-      SH_FREE(user);
-    }
-  return;
-}
-
-void sh_userid_destroy ()
-{
-  struct user_id * tmp_uid;
-  struct user_id * tmp_gid;
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_cache);
-  tmp_gid  = gid_list;
-  gid_list = NULL;
-  tmp_uid  = uid_list;
-  uid_list = NULL;
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_cache);
-
-  sh_userid_free(tmp_uid);
-  sh_userid_free(tmp_gid);
-  return;
-}
-
-static void sh_userid_additem(struct user_id * list, struct user_id * item)
-{
-  if (list)
-    {
-      while (list && list->next)
-	list = list->next;
-      list->next = item;
-    }
-  return;
-}
-
-static void sh_userid_add(uid_t id, char * username, int which)
-{
-  size_t len;
-  struct user_id * user = SH_ALLOC(sizeof(struct user_id));
-
-  if (username)
-    len  = strlen(username) + 1;
-  else
-    len = 1;
-
-  user->name = SH_ALLOC(len);
-  user->id   = id;
-  if (username)
-    sl_strlcpy(user->name, username, len);
-  else
-    user->name[0] = '\0';
-  user->next = NULL;
-
-  SH_MUTEX_LOCK(mutex_cache);
-  if (which == CACHE_UID)
-    {
-      if (!uid_list)
-	uid_list = user;
-      else
-	sh_userid_additem(uid_list, user);
-    }
-  else
-    {
-      if (!gid_list)
-	gid_list = user;
-      else
-	sh_userid_additem(gid_list, user);
-    }
-  SH_MUTEX_UNLOCK(mutex_cache);
-
-  return;
-}
-
-static char * sh_userid_search(struct user_id * list, uid_t id)
-{
-  while (list)
-    {
-      if (list->id == id)
-	return list->name;
-      list = list->next;
-    }
-  return NULL;
-}
-
-static char * sh_userid_get (uid_t id, int which, char * out, size_t len)
-{
-  char * user = NULL;
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_cache);
-  if (which == CACHE_UID)
-    user = sh_userid_search(uid_list, id);
-  else
-    user = sh_userid_search(gid_list, id);
-  if (user)
-    {
-      sl_strlcpy(out, user, len);
-      user = out;
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_cache);
-
-  return user;
-}
-
-/* --------- end caching code --------- */
-
-#include "sh_subuid.h"
-
-char *  sh_unix_getUIDname (int level, uid_t uid, char * out, size_t len)
+char *  sh_unix_getUIDname (int level, uid_t uid)
 {
   struct passwd * tempres;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWUID_R)
-  struct passwd pwd;
-  char   * buffer;
-#endif
   int             status = 0;
-  char errbuf[SH_ERRBUF_SIZE];
-  char * tmp;
+  static uid_t    old_uid;
+  static char     name[32] = { '\0' };
 
   SL_ENTER(_("sh_unix_getUIDname"));
 
-  tmp = sh_userid_get(uid, CACHE_UID, out, len);
-
-  if (tmp)
-    {
-      if (tmp[0] != '\0')
-	{
-	  SL_RETURN( out, _("sh_unix_getUIDname"));
-	}
-      else
-	{
-	  SL_RETURN( NULL, _("sh_unix_getUIDname"));
-	}
-    }
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWUID_R)
-  buffer = SH_ALLOC(SH_PWBUF_SIZE);
-  sh_getpwuid_r(uid, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
+  if ((uid == old_uid) && (name[0] != '\0')) {
+    SL_RETURN( name, _("sh_unix_getUIDname"));
+  }
+
   errno = 0;
   tempres = sh_getpwuid(uid);
   status = errno;
-#endif
-
-  /* case 1: we have it
-   */
-  if (tempres && tempres->pw_name != NULL) 
-    {
-
-      sl_strlcpy(out, tempres->pw_name, len);
-      sh_userid_add(uid, out, CACHE_UID);
-      
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-      SH_FREE(buffer);
-#endif
-
-      SL_RETURN( out, _("sh_unix_getUIDname"));
-    }
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-  SH_FREE(buffer);
-#endif
-  
-  if (tempres == NULL) 
-    {
-      char * pwname = sh_get_subuid ((unsigned long) uid);
-
-      if (pwname)
-	{
-	  sl_strlcpy(out, pwname, len);
-	  sh_userid_add(uid, out, CACHE_UID);
-	  SL_RETURN( out, _("sh_unix_getUIDname"));
-	}
-
-      sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_PWNULL,
-		       sh_error_message(status, errbuf, sizeof(errbuf)),
-		       _("getpwuid"), (long) uid, _("completely missing"));
-      sh_userid_add(uid, NULL, CACHE_UID);
-      SL_RETURN( NULL, _("sh_unix_getUIDname"));
-    }
-
-
-  /* getwpuid returns struct, but no pw_name
-   */
-  sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_PWNULL,
-		   sh_error_message(status, errbuf, sizeof(errbuf)),
-		   _("getpwuid"), (long) uid, _("pw_user"));
-  SL_RETURN( NULL, _("sh_unix_getUIDname"));
-}
-
-char *  sh_unix_getGIDname (int level, gid_t gid, char * out, size_t len)
+ 
+  if (tempres == NULL) {
+    sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_PWNULL,
+		     sh_error_message(status),
+		     _("getpwuid"), (long) uid, _("completely missing"));
+    SL_RETURN( NULL, _("sh_unix_getUIDname"));
+  }
+
+
+  if (tempres->pw_name != NULL) {
+    sl_strlcpy(name, tempres->pw_name, sizeof(name));
+    old_uid = uid;
+    SL_RETURN( name, _("sh_unix_getUIDname"));
+  } else {
+    sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_PWNULL,
+		     sh_error_message(status),
+		     _("getpwuid"), (long) uid, _("pw_user"));
+    SL_RETURN( NULL, _("sh_unix_getUIDname"));
+  }
+}
+
+char *  sh_unix_getGIDname (int level, gid_t gid)
 {
   struct group  * tempres;
   int             status = 0;
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-  struct group    grp;
-  char          * buffer;
-#endif
-  char errbuf[SH_ERRBUF_SIZE];
-  char * tmp;
+  static gid_t    old_gid;
+  static char     name[32] = { '\0' };
+
+  SL_ENTER(_("sh_unix_getGIDname"));
+
+  if ((gid == old_gid) && (name[0] != '\0')) {
+    SL_RETURN( name, _("sh_unix_getUIDname"));
+  }
   
-  SL_ENTER(_("sh_unix_getGIDname"));
-
-  tmp = sh_userid_get((uid_t)gid, CACHE_GID, out, len);
-
-  if (tmp)
-    {
-      if (tmp[0] != '\0')
-	{
-	  SL_RETURN( out, _("sh_unix_getGIDname"));
-	}
-      else
-	{
-	  SL_RETURN( NULL, _("sh_unix_getGIDname"));
-	}
-    }
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-  buffer = SH_ALLOC(SH_GRBUF_SIZE);
-  status = sh_getgrgid_r(gid, &grp, buffer, SH_GRBUF_SIZE, &tempres);
-#else
   errno = 0;
   tempres = sh_getgrgid(gid);
   status = errno;
-#endif
-
-  if (status == ERANGE) 
-    {
-      static int seen = 0;
-
-      if (seen == 0)
-	{
-	  sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, EINVAL, MSG_E_GRNULL,
-			   sh_error_message(status, errbuf, sizeof(errbuf)),
-			   _("getgrgid"), (long) gid, _("line too long in group entry"));
-	  ++seen;
-	}
+
+  if (tempres == NULL) {
+    sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_GRNULL,
+		     sh_error_message(status),
+		     _("getgrgid"), (long) gid, _("completely missing"));
       
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-      SH_FREE(buffer);
-#endif
-
-      sh_userid_add(gid, NULL, CACHE_GID);
-      SL_RETURN( NULL, _("sh_unix_getGIDname"));
-    }
-
-  if (tempres && tempres->gr_name != NULL) 
-    {
-
-      sl_strlcpy(out, tempres->gr_name, len);
-      sh_userid_add((uid_t)gid, out, CACHE_GID);
-      
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-      SH_FREE(buffer);
-#endif
-
-      SL_RETURN( out, _("sh_unix_getGIDname"));
-    } 
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETGRGID_R)
-  SH_FREE(buffer);
-#endif
-
-  if (tempres == NULL) 
-    {
-      char * grname = sh_get_subgid ((unsigned long) gid);
-
-      if (grname)
-	{
-	  sl_strlcpy(out, grname, len);
-	  sh_userid_add((uid_t)gid, out, CACHE_GID);
-	  SL_RETURN( out, _("sh_unix_getGIDname"));
-	}
-
-      sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_GRNULL,
-		       sh_error_message(status, errbuf, sizeof(errbuf)),
-		       _("getgrgid"), (long) gid, _("completely missing"));
-      sh_userid_add(gid, NULL, CACHE_GID);
-      SL_RETURN( NULL, _("sh_unix_getGIDname"));
-    }
-
-  sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_GRNULL,
-		   sh_error_message(status, errbuf, sizeof(errbuf)),
-		   _("getgrgid"), (long) gid, _("gr_name"));
-  SL_RETURN( NULL, _("sh_unix_getGIDname"));
+    SL_RETURN( NULL, _("sh_unix_getGIDname"));
+  }
+
+  if (tempres->gr_name != NULL) {
+    sl_strlcpy(name, tempres->gr_name, sizeof(name));
+    old_gid = gid;
+    SL_RETURN( name, _("sh_unix_getGIDname"));
+  } else {
+    sh_error_handle (level, FIL__, __LINE__, EINVAL, MSG_E_GRNULL,
+		     sh_error_message(status),
+		     _("getgrgid"), (long) gid, _("gr_name"));
+    SL_RETURN( NULL, _("sh_unix_getGIDname"));
+  }
 }
 
@@ -3009,6 +2240,4 @@
   char          * p;
   uid_t  seuid, sruid;
-  char   user[USER_MAX];
-  char   dir[SH_PATHBUF];
 
   SL_ENTER(_("sh_unix_getUser"));
@@ -3018,5 +2247,5 @@
   sh.effective.uid = seuid;
 
-  p = sh_unix_getUIDdir (SH_ERR_ERR, seuid, dir, sizeof(dir));
+  p = sh_unix_getUIDdir (SH_ERR_ERR, seuid);
 
   if (p == NULL)
@@ -3037,5 +2266,5 @@
   sh.real.uid = sruid;
 
-  p = sh_unix_getUIDname (SH_ERR_ERR, sruid, user, sizeof(user));
+  p = sh_unix_getUIDname (SH_ERR_ERR, sruid);
   if (p == NULL)
     SL_RETURN((-1), _("sh_unix_getUser"));
@@ -3051,5 +2280,5 @@
     }
 
-  p = sh_unix_getUIDdir (SH_ERR_ERR, sruid, dir, sizeof(dir));
+  p = sh_unix_getUIDdir (SH_ERR_ERR, sruid);
 
   if (p == NULL)
@@ -3071,5 +2300,5 @@
 }
 
-/* return >0 on success, -1 on EOF */
+
 int sh_unix_getline (SL_TICKET fd, char * line, int sizeofline)
 {
@@ -3081,9 +2310,7 @@
 
   if (sizeofline < 2) {
-    line[0] = '\0';
+    line[n] = '\0';
     SL_RETURN((0), _("sh_unix_getline"));
   }
-
-  --sizeofline;
 
   while (n < sizeofline) {
@@ -3133,7 +2360,7 @@
  **************************************************************/
 
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
-
-#if defined(__linux__)
+#if defined(__linux__) 
+
+#if defined(HAVE_LINUX_EXT2_FS_H) || defined(HAVE_EXT2FS_EXT2_FS_H)
 
 /* --- Determine ext2fs file attributes. ---
@@ -3142,9 +2369,6 @@
 #if defined(HAVE_EXT2FS_EXT2_FS_H)
 #include <ext2fs/ext2_fs.h>
-#elif defined(HAVE_LINUX_EXT2_FS_H)
+#else
 #include <linux/ext2_fs.h>
-#endif
-
-/* __linux__ includes */
 #endif
 
@@ -3153,5 +2377,5 @@
 			  unsigned long * flags, 
 			  char * c_attr,
-			  int fd, struct stat * buf)
+			  int fd)
 {
 
@@ -3169,4 +2393,6 @@
 
 #ifdef HAVE_STAT_FLAGS
+  struct stat buf;
+  int    i;
 
   SL_ENTER(_("sh_unix_getinfo_attr"));
@@ -3174,76 +2400,30 @@
   *flags = 0;
 
-  /* cast to void to avoid compiler warning about unused parameters */
-  (void) fd;
-  (void) name;
-
+  i = retry_stat (FIL__, __LINE__, name, &buf);
+
+  if (i == -1)
+    SL_RETURN(-1, _("sh_unix_getinfo_attr"));
+
+#ifdef UF_IMMUTABLE
+  if (buf.st_flags & UF_IMMUTABLE)
+    *flags |= EXT2_IMMUTABLE_FL;
+#endif
+#ifdef UF_APPEND
+  if (buf.st_flags & UF_APPEND)
+    *flags |= EXT2_APPEND_FL;
+#endif
 #ifdef UF_NODUMP
-  if (buf->st_flags & UF_NODUMP) {
-    *flags |= UF_NODUMP;
-    c_attr[0] = 'd';
-  }
-#endif
-#ifdef UF_IMMUTABLE
-  if (buf->st_flags & UF_IMMUTABLE) {
-    *flags |= UF_IMMUTABLE;
-    c_attr[1] = 'i';
-  }
-#endif
-#ifdef UF_APPEND
-  if (buf->st_flags & UF_APPEND) {
-    *flags |= UF_APPEND;
-    c_attr[2] = 'a';
-  }
-#endif
-#ifdef UF_NOUNLINK
-  if (buf->st_flags & UF_NOUNLINK) {
-    *flags |= UF_NOUNLINK;
-    c_attr[3] = 'u';
-  }
-#endif
-#ifdef UF_OPAQUE
-  if (buf->st_flags & UF_OPAQUE) {
-    *flags |= UF_OPAQUE;
-    c_attr[4] = 'o';
-  }
-#endif
-#ifdef SF_ARCHIVED
-  if (buf->st_flags & SF_ARCHIVED) {
-    *flags |= SF_ARCHIVED;
-    c_attr[5] = 'R';
-  }
-    
-#endif
-#ifdef SF_IMMUTABLE
-  if (buf->st_flags & SF_IMMUTABLE) {
-    *flags |= SF_IMMUTABLE;
-    c_attr[6] = 'I';
-  }
-#endif
-#ifdef SF_APPEND
-  if (buf->st_flags & SF_APPEND) {
-    *flags |= SF_APPEND;
-    c_attr[7] = 'A';
-  }
-#endif
-#ifdef SF_NOUNLINK
-  if (buf->st_flags & SF_NOUNLINK) {
-    *flags |= SF_NOUNLINK;
-    c_attr[8] = 'U';
-  }
-#endif
-
-  /* ! HAVE_STAT_FLAGS */
+  if (buf.st_flags & UF_NODUMP)
+    *flags |= EXT2_NODUMP_FL;
+#endif
+
 #else
 
 #ifdef HAVE_EXT2_IOCTLS
   int /* fd, */ r, f;
-  unsigned long keep_flags = 0;
   
   SL_ENTER(_("sh_unix_getinfo_attr"));
 
   *flags = 0;
-  
-  (void) buf;
 
   /* open() -> aud_open() R.Wichmann 
@@ -3255,16 +2435,13 @@
 
   
-  r = ioctl (fd, FS_IOC_GETFLAGS, &f);
-  /* sl_close_fd (FIL__, __LINE__, fd); */
+  r = ioctl (fd, EXT2_IOC_GETFLAGS, &f);
+  /* close (fd); */
 
   if (r == -1)
     SL_RETURN(-1, _("sh_unix_getinfo_attr"));
 
-  if (f == 0)
-    SL_RETURN(0, _("sh_unix_getinfo_attr"));
-
   *flags = f;
 
-/* ! HAVE_FS_IOCTLS */
+/* ! HAVE_EXT2_IOCTLS */
 #else 
 
@@ -3273,6 +2450,7 @@
   *flags = 0;                                     /* modified by R.Wichmann */
 
-/* ! HAVE_FS_IOCTLS */
+/* ! HAVE_EXT2_IOCTLS */
 #endif 
+#endif
 /*
  * END
